structure Tokens = Tokens
structure Interface = Interface

open Interface

type pos = Interface.pos
type svalue = Tokens.svalue
type ('a,'b) token = ('a,'b) Tokens.token
type lexresult = (svalue,pos) token

fun eof() = Tokens.EOF(!line,!line)
fun makeInt (s : string) = s

%%  
%header (functor NL_LexFun(structure Tokens: NL__TOKENS
                           structure Interface: INTERFACE) : LEXER);
%full 

idchars=[0-9]|[_&+/@|#*`'><];   
alpha=[a-zA-Z];
comment=%(.*)\n;
whitespace=[\t\ ]*;
%%
<INITIAL>{whitespace} => (lex());
{comment}  => (next_line(); lex());
\n         => (next_line(); lex());
"."        => (Tokens.PUNKT(!line,!line));
"und"      => (Tokens.und(!line,!line));
"oder"     => (Tokens.oder(!line,!line));
"nicht"    => (Tokens.nicht(!line,!line));
"ist"      => (Tokens.ist(!line,!line));
"Anna"     => (Tokens.PN(D.Anna,!line,!line));
"Dieter"   => (Tokens.PN(D.Dieter,!line,!line));
"Emil"     => (Tokens.PN(D.Emil,!line,!line));
"Maria"    => (Tokens.PN(D.Maria,!line,!line));
"Mann"     => (Tokens.N(D.Mann,!line,!line));
"Frau"     => (Tokens.N(D.Frau,!line,!line));
"Student"  => (Tokens.N(D.Student,!line,!line));
"arbeitet" => (Tokens.IV(D.arbeiten,!line,!line));
"kennt"    => (Tokens.TV(D.kennen,!line,!line));
"liebt"    => (Tokens.TV(D.lieben,!line,!line));
("ein" | "eine") => (Tokens.ein(!line,!line));
"eines"    => (Tokens.eines(!line,!line));
"Nachbar"  => (Tokens.N2(D.Nachbar,!line,!line));  
"Bruder"   => (Tokens.N2(D.Bruder,!line,!line));  
"arbeiten" => (Tokens.IV(D.arbeiten,!line,!line));
"kennen"   => (Tokens.TV(D.kennen,!line,!line));
"lieben"   => (Tokens.TV(D.lieben,!line,!line));
"gesund"   => (Tokens.CA(D.gesund,!line,!line));
"jeden"    => (Tokens.UQ(!line,!line));
"einen"    => (Tokens.EQ(!line,!line));
"keinen"   => (Tokens.NQ(!line,!line));
"sind"     => (Tokens.sind(!line,!line));
.          => (error ("ignoring illegal character " ^ yytext,
                      !line,!line); lex());

